#define ACS712PIN A3 
#define BETRIEBSSPANNUNG 4.85    // VSS in Volt
#define SENSITIVITY 100        // Empfindlichkeit in mV/A

#define MEDIAN 512

volatile unsigned long sumMesswerte,countMesswerte;

void einMesswert() {
  sumMesswerte += abs(analogRead(ACS712PIN)-MEDIAN);
  countMesswerte++;
}

void auswertung()
{
  char buffer[35];
  int messwert;
  float strom;
  long spannungMV,stromMA;
  if (countMesswerte>=1000)
  {
    noInterrupts();
    messwert= sumMesswerte/countMesswerte;
    sumMesswerte=0;
    countMesswerte=0;
    interrupts();
    spannungMV= messwert / 1023.0 * BETRIEBSSPANNUNG  * 1000L;
    stromMA=spannungMV*1000/SENSITIVITY;
    snprintf(buffer,sizeof(buffer),"%d - %ld mV - %ld mA",messwert,spannungMV,stromMA);
    Serial.println(buffer);
  }
}


void stopTimer0() {
    // ensure that the standard timer interrupts will not
    // mess with msTimer2
    TIMSK0 = 0;
}

ISR(TIMER2_COMPA_vect) {
  einMesswert();
}

void initTimer2() {
    // Timer 2 CTC mode, prescaler 64
    TCCR2B = (1<<WGM22) | (1<<CS22);
    TCCR2A = (1<<WGM21);
    // 249 + 1 == 250 == 250 000 / 1000 =  (16 000 000 / 64) / 1000
    OCR2A = 249;
    // enable Timer 2 interrupts
    TIMSK2 = (1<<OCIE2A);
}


void setup() {
    Serial.begin(9600);
    Serial.println();
    Serial.println("ACS712 Test Program by 'jurs' for German Arduino Forum");
    Serial.println();
    initTimer2();
    stopTimer0();
}


void loop() {
  auswertung();
}

